/*
	AdLib 262 Library - Source Modification by Park Jeenhong
	Version 1.22

	[ Notice ]

	You may use this source as you like, and modify freely as you want.
	But before you modify this source, please compare assembly output
	with	that of original source.

	Compiler : Turbo C++ 3.0, Borland International
	Memory Model : Large
*/

#ifndef	__TURBOC__
#error This program should be compiled with Turbo C++ 3.0
#endif

#ifndef	__LARGE__
#error This program should be compiled in Large Model
#endif

#define MK_FP(seg, off) ((void _seg *)(seg)+(void near *)(off));

/* Parameters of each voice: */
#define nbLocParam		14

#define prmKsl			0
#define prmMulti		1
#define prmFeedBack	2			/* use for opr. 0 only */
#define prmAttack		3
#define prmSustain		4
#define prmStaining	5			/* Sustaining ... */
#define prmDecay		6
#define prmRelease		7
#define prmLevel		8
#define prmAm			9
#define prmVib			10
#define prmKsr			11
#define prmFm			12			/* use for opr. 0 only */
#define prmWaveSel		13			/* wave select */

/* percussive voice numbers: */
#define BD			6
#define SD			7
#define TOM			8
#define CYMB			9
#define HIHAT			10

#define MAX_VOLUME		0x7f
#define LOG2_VOLUME		7			/* log2( MAX_VOLUME) */
#define MAX_PITCH		0x3fff
#define MID_PITCH		0x2000

#define MID_C			60			/* MIDI standard mid C */
#define CHIP_MID_C		48			/* sound chip mid C */
#define NR_NOTES		96			/* # of notes we can play on chip */


#define N_V near
#define TOM_PITCH	24				/* best frequency, in range of 0 to 95 */
#define TOM_TO_SD	7				/* 7 half-tones between voice 7 & 8 */
#define SD_PITCH	(TOM_PITCH + TOM_TO_SD)

#define GetLocPrm(slot, prm) ((unsigned)paramSlot [slot] [prm])

#define NB_NOTES			96      /* 8 octave of 12 notes */
#define OCTAVE				12      /* half-tone by octave */
#define NB_STEP_PITCH		16      /* 16 steps between two half-tones */
#define LOG_NB_STEP_PITCH	4       /* LOG2( NB_STEP_PITCH) */
#define LOG_PITCH			8       /* LOG2( TABLE_SIZE) */
#define TABLE_SIZE			(NB_STEP_PITCH * NB_TABLE_DEMI_TON)
#define NB_TABLE_DEMI_TON	OCTAVE

static const int		N_V	fNumTbl[]={
	   0x02B2, 0x02B4, 0x02B7, 0x02B9, 0x02BC, 0x02BE, 0x02C1, 0x02C3, 0x02C6, 0x02C9,
	   0x02CB, 0x02CE, 0x02D0, 0x02D3, 0x02D6, 0x02D8, 0x02DB, 0x02DD, 0x02E0, 0x02E3,
	   0x02E5, 0x02E8, 0x02EB, 0x02ED, 0x02F0, 0x02F3, 0x02F6, 0x02F8, 0x02FB, 0x02FE,
	   0x0301, 0x0303, 0x0306, 0x0309, 0x030C, 0x030F, 0x0311, 0x0314, 0x0317, 0x031A,
	   0x031D, 0x0320, 0x0323, 0x0326, 0x0329, 0x032B, 0x032E, 0x0331, 0x0334, 0x0337,
	   0x033A, 0x033D, 0x0340, 0x0343, 0x0346, 0x0349, 0x034C, 0x034F, 0x0352, 0x0356,
	   0x0359, 0x035C, 0x035F, 0x0362, 0x0365, 0x0368, 0x036B, 0x036F, 0x0372, 0x0375,
	   0x0378, 0x037B, 0x037F, 0x0382, 0x0385, 0x0388, 0x038C, 0x038F, 0x0392, 0x0395,
	   0x0399, 0x039C, 0x039F, 0x03A3, 0x03A6, 0x03A9, 0x03AD, 0x03B0, 0x03B4, 0x03B7,
	   0x03BB, 0x03BE, 0x03C1, 0x03C5, 0x03C8, 0x03CC, 0x03CF, 0x03D3, 0x03D7, 0x03DA,
	   0x03DE, 0x03E1, 0x03E5, 0x03E8, 0x03EC, 0x03F0, 0x03F3, 0x03F7, 0x03FB, 0x03FE,
	   0xFE01, 0xFE03, 0xFE05, 0xFE07, 0xFE08, 0xFE0A, 0xFE0C, 0xFE0E, 0xFE10, 0xFE12,
	   0xFE14, 0xFE16, 0xFE18, 0xFE1A, 0xFE1C, 0xFE1E, 0xFE20, 0xFE21, 0xFE23, 0xFE25,
	   0xFE27, 0xFE29, 0xFE2B, 0xFE2D, 0xFE2F, 0xFE31, 0xFE34, 0xFE36, 0xFE38, 0xFE3A,
	   0xFE3C, 0xFE3E, 0xFE40, 0xFE42, 0xFE44, 0xFE46, 0xFE48, 0xFE4A, 0xFE4C, 0xFE4F,
	   0xFE51, 0xFE53, 0xFE55, 0xFE57, 0xFE59, 0xFE5C, 0xFE5E, 0xFE60, 0xFE62, 0xFE64,
	   0xFE67, 0xFE69, 0xFE6B, 0xFE6D, 0xFE6F, 0xFE72, 0xFE74, 0xFE76, 0xFE79, 0xFE7B,
	   0xFE7D, 0xFE7F, 0xFE82, 0xFE84, 0xFE86, 0xFE89, 0xFE8B, 0xFE8D, 0xFE90, 0xFE92,
	   0xFE95, 0xFE97, 0xFE99, 0xFE9C, 0xFE9E, 0xFEA1, 0xFEA3, 0xFEA5, 0xFEA8, 0xFEAA,
	   0xFEAD, 0xFEAF
};

static const char		N_V	noteDIV12[]={
	   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  1,  1,
	   1,  1,  1,  1,  1,  1,  1,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,
	   2,  2,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  4,  4,  4,
	   4,  4,  4,  4,  4,  4,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,
	   5,  5,  5,  5,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  7,
	   7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7
};

static const char		N_V	noteMOD12[]={
	   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11,  0,  1,  2,  3,  4,
	   5,  6,  7,  8,  9, 10, 11,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9,
	   10, 11,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11,  0,  1,  2,
	   3,  4,  5,  6,  7,  8,  9, 10, 11,  0,  1,  2,  3,  4,  5,  6,  7,
	   8,  9, 10, 11,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11,  0,
	   1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11
};

static unsigned		N_V	genAddr;			/* addr. of sound chip, in DS, used by OUTCHIP.ASM */
static unsigned char	N_V	ymbuf[96];

static unsigned char	N_V	StereoStatus=0, YM262Status=0, EffectStatus=0;

static unsigned char	N_V	Stereo[]={
	0x10, 0x20, 0x10, 0x20, 0x10, 0x20, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00
};

static int	N_V 	modeWaveSel;		/* != 0 if used with the 'wave-select' parameters */

static char	N_V	percBits;			/* control bits of percussive voices */
static const char N_V percMasks[] = {
	0x10, 0x08, 0x04, 0x02, 0x01
};

static char N_V voiceNote [9];          /* pitch of last note-on of each voice */
static char N_V voiceKeyOn [9];     /* state of keyOn bit of each voice */
static unsigned N_V vPitchBend [9]; /* current pitch bend of each voice */
static char N_V bxRegister [9];     /* current val. of 0xB0 - 0xB8 reg */
static unsigned char N_V VoiceVolume [11];      /* volume for each of 11 logical voices */

static unsigned N_V modeVoices;		/* 9 or 11, depending on 'percussion'*/



/* definition of the ELECTRIC-PIANO voice (opr0 & opr1) */
static const char N_V pianoParamsOp0 [nbLocParam] = {
	1, 1, 3, 15, 5, 0, 1, 3, 15, 0, 0, 0, 1, 0 };
static const char N_V pianoParamsOp1 [nbLocParam] = {
	0, 1, 1, 15, 7, 0, 2, 4, 0, 0, 0, 1, 0, 0 };

/* definition of default percussive voices: */
static const char N_V bdOpr0[] =  {0,  0, 0, 10,  4, 0, 8, 12, 11, 0, 0, 0, 1, 0 };
static const char N_V bdOpr1[] =  {0,  0, 0, 13,  4, 0, 6, 15,  0, 0, 0, 0, 1, 0 };
static const char N_V sdOpr[] =   {0, 12, 0, 15, 11, 0, 8,  5,  0, 0, 0, 0, 0, 0 };
static const char N_V tomOpr[] =  {0,  4, 0, 15, 11, 0, 7,  5,  0, 0, 0, 0, 0, 0 };
static const char N_V cymbOpr[] = {0,  1, 0, 15, 11, 0, 5,  5,  0, 0, 0, 0, 0, 0 };
static const char N_V hhOpr[] =   {0,  1, 0, 15, 11, 0, 7,  5,  0, 0, 0, 0, 0, 0 };

static char N_V paramSlot [18] [nbLocParam];    /* all the parameters of slots...  */

static char	N_V amDepth;			/* chip global parameters .. */
static char	N_V vibDepth;			/* ... */
static char	N_V noteSel;			/* ... */
static char	N_V percussion;		/* percussion mode parameter */

/* Slot numbers as a function of the voice and the operator.
   (melodic mode only)
*/
static unsigned char N_V slotMVoice [9]  [2] = {
	{0, 3},		/* voix 0 */
	{1, 4},		/* 1 */
	{2, 5},		/* 2 */
	{6, 9},		/* 3 */
	{7, 10},	/* 4 */
	{8, 11},	/* 5 */
	{12, 15},	/* 6 */
	{13, 16},	/* 7 */
	{14, 17}	/* 8 */
};


/* Slot numbers for the percussive voices.
   255 indicates that there is only one slot used by a voice.
*/
unsigned char N_V slotPVoice [11]  [2] = {
	{0, 3},		/* voice 0 */
	{1, 4},		/* 1 */
	{2, 5},		/* 2 */
	{6, 9},		/* 3 */
	{7, 10},	/* 4 */
	{8, 11},	/* 5 */
	{12, 15},	/* Bass Drum: slot 12 et 15 */
	{16, 255},	/* SD: slot 16 */
	{14, 255},	/* TOM: slot 14 */
	{17, 255},	/* TOP-CYM: slot 17 */
	{13, 255}	/* HH: slot 13 */
};

/*
	This table gives the offset of each slot within the chip.
	offset = fn (slot)
*/
static const char N_V offsetSlot[] = {
	 0,  1,  2,  3,  4,  5,
	 8,  9, 10, 11, 12, 13,
	16, 17, 18, 19, 20, 21
};


/* This table indicates if the slot is a modulator (operator 0) or a
   carrier (operator 1).
   opr = fn (slot)
*/
static const char N_V carrierSlot[] = {
	0, 0, 0,		/* 1 2 3 */
	1, 1, 1,		/* 4 5 6 */
	0, 0, 0, 		/* 7 8 9 */
	1, 1, 1, 		/* 10 11 12 */
	0, 0, 0, 		/* 13 14 15 */
	1, 1, 1		/* 16 17 18 */
};

/* This table gives the voice number associated with each slot.
   (melodic mode only)
   voice = fn (slot)
*/
static const char N_V voiceMSlot[] = {
	0, 1, 2,
	0, 1, 2,
	3, 4, 5,
	3, 4, 5,
	6, 7, 8,
	6, 7, 8
};


/* This table gives the voice number  (0-10) associated with each
   slot (percussive mode only),
   voice = fn (slot)
*/
static const char N_V voicePSlot[] = {
	0, 1, 2,
	0, 1, 2,
	3, 4, 5,
	3, 4, 5,
	BD, HIHAT, TOM,
	BD, SD, CYMB
};


/*----------------------------------------------------------
   Function prototypes.
*/

static void near InitSlotParams();
static void near SetSlotParam (unsigned, unsigned *, unsigned);
static void near SndSetAllPrm (int);
static void near SndSKslLevel (int);
static void near SndSNoteSel();
static void near SndSAmVibRhythm();
static void near UpdateFNums (int);
static near int BoardInstalled();
static void NoV(void);
static void SetStereo_RE (int chan);
static void SetStereo_RNE(int chan);
static void SndOutput2_S (int addr, int value);
static void SndOutput3_S (int addr, int value);
static void (*SndOutput2) ();
static void (*SndOutput3) ();
static void (*SetStereo1) ();

void SoundWarmInit();
void SetMode ();
void SetWaveSel ();
void SetGParam ();
void SndOutput(int, int);

int SoundColdInit (port)
unsigned port;                  /* io port address of sound board (0x388) */
{
	int i, hardware;
	unsigned PORT_NUM[]={
		0x388, 0x220, 0x240, 0x260, 0x280,
		0x228, 0x248, 0x268, 0x288
	};

	asm {
		jmp NET
		db	'AdLib 262 Library V1.22 - Copyright (c) 1996, Park Jeenhong', 0
	}

NET:	SndOutput2=&SndOutput;
	SndOutput3=&NoV;
	SetStereo1=&NoV;

	if(port!=0) {
		genAddr = port;
		hardware =  BoardInstalled();
	}
	else {
		hardware=0;
		for(i=0; i<9; i++) {
			genAddr = PORT_NUM[i];
			hardware =  BoardInstalled();
			if(hardware) break;
		}
		if(!hardware) {
			genAddr = 0x388;
			hardware =  BoardInstalled();
		}
	}

	if(StereoStatus==0) {
		if((inp(genAddr)&0x06)==0 && ((genAddr&0x000F)==0 || genAddr==0x388)) {
			YM262Status=1;
			SndOutput2=&SndOutput2_S;
			SndOutput3=&SndOutput3_S;
			if(EffectStatus==0) SetStereo1=&SetStereo_RNE;
			else SetStereo1=&SetStereo_RE;
		}
		else YM262Status=0;
	}
	else {
		if(StereoStatus==1 && ((genAddr&0x000F)==0 || genAddr==0x388)) {
			YM262Status=1;
			SndOutput2=&SndOutput2_S;
			SndOutput3=&SndOutput3_S;
			if(EffectStatus==0) SetStereo1=&SetStereo_RNE;
			else SetStereo1=&SetStereo_RE;
		}
		else YM262Status=0;
	}

	SoundWarmInit();

	return hardware;
}   /* SoundColdInit() */


void SoundWarmInit()
{
	int i;

	for(i=1;i<=0xF5;i++) SndOutput2(i, 0);	/* clear all registers */

	SndOutput(4, 6);				/* mask T1 & T2 */

	if(YM262Status) {
		SndOutput3_S(5, 1);			/* YMF-262M Mode */
		SndOutput3_S(4, 0);
	}
	else SndOutput3_S(5, 0);

	for (i = 0; i < 9; i++)  {      /* pitch bend for each voice = no detune */
		vPitchBend [i] = MID_PITCH;
		voiceKeyOn [i] = 0;
		voiceNote [i] = 0;
	}

	for (i = 0; i < 11; i++) VoiceVolume [i] = MAX_VOLUME;

	SetMode (0);                /* melodic mode */
	SetGParam (0, 0, 0);        /* init global parameters */
	SetWaveSel (1);
}   /* SoundWarmInit() */



/*
---------------------------------------------
	Put the chip in melodic mode (mode == 0),
	or in percussive mode  (mode != 0).

	If the melodic mode is chosen, all voices are
	set to electric-piano, else the first 5 are set
	to electric-piano, and the percussion voices
	to their default timbres.
---------------------------------------------
*/
void SetMode (mode)
int mode;
{
	if (mode){
		/* set the frequency for the last 4 percussion voices: */
		voiceNote [TOM] = TOM_PITCH;
		voiceNote [SD] = SD_PITCH;
		vPitchBend [TOM] = (vPitchBend [SD] = MID_PITCH);

		UpdateFNums (TOM);
		UpdateFNums (SD);
	}

	percussion = mode;
	modeVoices = mode ? 11 : 9;
	percBits = 0;

	InitSlotParams();
	SndSAmVibRhythm();
}   /* SetMode() */




/*
	Enable (state != 0) / disable (state == 0)
	the wave-select parameters.

	If you do not want to use the wave-select parameters, call
	this function with a value of 0 AFTER calling SoundColdInit()
	or SoundWarmInit().
*/

void SetWaveSel (state)
{
	int i;

	modeWaveSel = state ? 0x20 : 0;
	for (i = 0; i < 18; i++) SndOutput2(0xE0 + offsetSlot [i], 0);
	SndOutput(1, modeWaveSel);
}   /* SetWaveSel() */


/*
----------------------------------------------
	Set the 3 global parameters AmDepth,
	VibDepth & NoteSel

	The change takes place immediately.
----------------------------------------------
*/
void SetGParam (amD, vibD, nSel)
int amD, vibD, nSel;
{
	amDepth = amD;
	vibDepth = vibD;
	noteSel = nSel;

	SndSAmVibRhythm();
	SndSNoteSel();
}   /* SetGParam() */





/*
-------------------------------------------------
	Set the parameters of the voice 'voice'.

	In melodic mode, 'voice' varies from 0 to 8.
	In percussive mode, voices 0 to 5 are melodic
	and 6 to 10 are percussive.

	A timbre (melodic or percussive) is defined as follows:
	the 13 first parameters of operator 0  (ksl, multi, feedBack,
	attack, sustain, eg-typem decay, release, level, am, vib, ksr, fm)
	followed by the 13 parameters of operator 1 (if a percussive voice, all
	the parameters are zero), followed by the wave-select parameter for
	the operators 0 and 1.

	'paramArray' is structured as follows:
		struct {
			int opr0Prm [13];       first 13 parameters
			int opr1Prm [13];       must be 0 if percussive timbre
			int	opr0WaveSel;		last parameter
			int opr1WaveSel;		must be 0 if percussive timbre
		} TimbreDef;

	The old timbre files (*.INS) do not contain the parameters
	'opr0WaveSel' and 'opr1WaveSel'.
	Set these two parameters to zero if you are using the old file
	format.
------------------------------------------------
*/
void SetVoiceTimbre (voice, paramArray)
unsigned voice;
unsigned * paramArray;
{
	unsigned wave0, wave1;
	unsigned char * slots;

	if (voice >= modeVoices) return;

	asm {
		les	bx, paramArray
		add	bx, 2 * ( nbLocParam - 1 ) * 2
		mov	ax, word ptr es:[bx]
		mov	wave0, ax
		mov	ax, word ptr es:[bx+2]
		mov	wave1, ax
	}

	if(percussion) slots = slotPVoice [voice];
	else slots = slotMVoice [voice];

	SetSlotParam (slots [0], paramArray, wave0);
	if (slots [1] != 255) SetSlotParam (slots [1], paramArray + nbLocParam - 1, wave1);

	SetStereo1(voice);
}   /* SetVoiceTimbre() */




/*
--------------------------------------------------
	Set the volume of the voice 'voice' to 'volume'.

	The resulting output level is (timbreVolume * volume / 127).
	The change takes place immediately.

	0 <= volume <= 127
--------------------------------------------------
*/
void SetVoiceVolume (voice, volume)
unsigned voice, volume;			  	/* 0 - 0x7f */
{
	unsigned char * slots;

	if ((_BX=voice) >= modeVoices) return;
	if (volume > MAX_VOLUME) volume = MAX_VOLUME;

	VoiceVolume [_BX] = volume;
	if(percussion) slots = slotPVoice [_BX];
	else slots = slotMVoice [_BX];

	SndSKslLevel (slots [0]);
	if (255 != slots [1]) SndSKslLevel (slots [1]);
}   /* SetVoiceVolume() */


/*
-------------------------------------------------
	Change the pitch value of a voice.

	The variation in pitch is a function of the previous call
	to 'SetPitchRange()' and the value of 'pitchBend'.
	A value of 0 means -half-tone * pitchRange,
	0x2000 means no variation (exact pitch) and
	0x3fff means +half-tone * pitchRange.

	Does not affect the percussive voices, except for the bass drum.

	The change takes place immediately.

	0 <= pitchBend <= 0x3fff, 0x2000 == exact tuning
-------------------------------------------------
*/
void SetVoicePitch (voice, pitchBend)
unsigned voice;
unsigned pitchBend;
{
	if (voice <= BD || (!percussion && voice < 9)) {
		/* melodic + bass-drum */
		if (pitchBend > MAX_PITCH) pitchBend = MAX_PITCH;
		vPitchBend [voice] = pitchBend;
		UpdateFNums (voice);
	}
}   /* SetVoicePitch() */



/*
-----------------------------------------------------------
	Routine to start a note playing.

	0 <= voice <= 8	in melodic mode,
	0 <= voice <= 10 in percussive mode;
	0 <= pitch <= 127, 60 == MID_C  (the card can play between 12 and 107 )
-----------------------------------------------------------
*/
void NoteOn (voice, pitch)
unsigned voice;
int pitch;				/* 0 - 127 */
{
	pitch -=  (MID_C - CHIP_MID_C);
	if (pitch < 0) pitch = 0;
	if ((!percussion && voice < 9) || voice < BD) {
		/* this is a melodic voice */
		voiceNote [voice] = pitch;
		voiceKeyOn [voice] = 0x20;
		UpdateFNums (voice);
	}
	else if (percussion && voice <= HIHAT) {
		/* this is a percussive voice */
		if (voice == BD) {
			voiceNote [BD] = pitch;
			UpdateFNums (BD);
		}
		else if (voice == TOM) {
			/* for the last 4 percussions, only the TOM may change in frequency,
				modifying the three others: */
			if (voiceNote [TOM] != pitch) {
				voiceNote [SD] = (voiceNote [TOM] = pitch) + TOM_TO_SD;
				UpdateFNums (TOM);
				UpdateFNums (SD);
			}
		}
		percBits |= percMasks [voice - BD];
		SndSAmVibRhythm();
	}
}   /* NoteOn() */


/*
	Routine to stop playing the note which was started in 'NoteOn()'.

	0 <= voice <= 8	in melodic mode,
	0 <= voice <= 10 in percussive mode;
*/
void NoteOff (voice)
unsigned voice;
{
	_BX=voice;

	if ((!percussion && _BX < 9) || _BX < BD) {
		voiceKeyOn [_BX] = 0;
		_AX = ( bxRegister [_BX] &= ~0x20 );
		SndOutput2(0xB0 + _BX, _AX);
	}
	else if (percussion && _BX <= HIHAT) {
		percBits &= ~percMasks [_BX - BD];
		SndSAmVibRhythm();
	}
}   /* NoteOff() */





/*
------------------------------------------------------------------------
	static functions ...
------------------------------------------------------------------------
*/


/*
	In melodic mode, initialize all voices to electric-pianos.

	In percussive mode, initialize the first 6 voices to electric-pianos
	and the percussive voices to their default timbres.
*/
static void near InitSlotParams()
{
	int i;

	for (i = 0; i < 18; i++)
		if (carrierSlot [i]) SetCharSlotParam (i, pianoParamsOp1, 0);
		else	SetCharSlotParam (i, pianoParamsOp0, 0);

	if (percussion) {
		SetCharSlotParam (12, bdOpr0, 0);
		SetCharSlotParam (15, bdOpr1, 0);
		SetCharSlotParam (16, sdOpr, 0);
		SetCharSlotParam (14, tomOpr, 0);
		SetCharSlotParam (17, cymbOpr, 0);
		SetCharSlotParam (13, hhOpr, 0);
	}
}	/* InitSlotParams() */


/*
------------------------------------------------------
	Set the 14 parameters  (13 in 'param', 1 in 'waveSel')
	of slot 'slot'. Update the parameter array and the chip.
------------------------------------------------------
*/
static void near SetSlotParam (slot, param, waveSel)
unsigned slot, * param, waveSel;
{
	char *ptrs = paramSlot [slot];

	asm {
		push	ds
		les	di, ptrs
		lds	si, param
		mov	cx, nbLocParam - 1
	}
L1:	asm {
		lodsw
		stosb
		loop	L1
		mov	ax, waveSel
		and	ax, 0x03
		mov	es:[di], al
		pop	ds
	}

	SndSetAllPrm (slot);
}	/* SetSlotParam() */

SetCharSlotParam (slot, cParam, waveSel)
unsigned slot, waveSel;
unsigned char * cParam;
{
	unsigned param [nbLocParam];

	asm {
		push	bp		// Param must be in the last of declaration of data
		mov	bp, sp
		add	bp, 2
		push	ds
		lds	bx, cParam
		mov	cx, nbLocParam - 1
		xor	ah, ah
	}
L1:	asm {
		mov	al, [bx]
		mov	word ptr [bp], ax
		add	bp, 2
		inc	bx
		loop	L1
		pop	ds
		pop	bp
	}

	SetSlotParam (slot, param, waveSel);

	return;
}	/* SetCharSlotParam() */


/*-------------------------------------------------
	Transfer all the parameters from slot 'slot' to
	the chip.
*/
static void near SndSetAllPrm (slot)
{
	SndSAmVibRhythm();
	SndSNoteSel();
	SndSKslLevel (slot);

	if (!carrierSlot [slot]) {
		_CX = GetLocPrm (slot, prmFeedBack) << 1;
		_CX |= GetLocPrm (slot, prmFm) ? 0 : 1;
		SndOutput2(0xC0 + (int)voiceMSlot [slot], _CX);
	}

	_CX = GetLocPrm (slot, prmAttack) << 4;
	_CX |= GetLocPrm (slot, prmDecay) & 0xf;
	SndOutput2(0x60 + (int)offsetSlot [slot], _CX);

	_CX = GetLocPrm (slot, prmSustain) << 4;
	_CX |= GetLocPrm (slot, prmRelease) & 0xf;
	SndOutput2(0x80 + (int)offsetSlot [slot], _CX);

	_CX = GetLocPrm (slot, prmAm) ? 0x80 : 0;
	_CX |= GetLocPrm (slot, prmVib) ? 0x40 : 0;
	_CX |= GetLocPrm (slot, prmStaining) ? 0x20 : 0;
	_CX |= GetLocPrm (slot, prmKsr) ? 0x10 : 0;
	_CX |= GetLocPrm (slot, prmMulti) & 0xf;
	SndOutput2(0x20 + (int)offsetSlot [slot], _CX);

	SndOutput2(0xE0 + offsetSlot [slot], (modeWaveSel ? GetLocPrm (slot, prmWaveSel) & 0x03 : 0));
}	/* SndSetAllPrm() */


/*
	Write to the register which controls output level and does
	key-on/key-offs for the percussive voice slots.
*/
static void near SndSKslLevel (slot)
{
	unsigned t1, t2, vc;

	if (percussion) vc = voicePSlot [slot];
	else vc = voiceMSlot [slot];

	t2 = (t1 = 63 - (GetLocPrm (slot, prmLevel) & 63));    /* amplitude */

	if(carrierSlot [slot] || !GetLocPrm (slot, prmFm) || (percussion && vc > BD)) {
		/* Change the 0 - 127 volume change value to 0 - 63 for the chip.
		   (MAX_VOLUME+1)/2 is added to avoid round-off errors. */
		_DX = VoiceVolume [vc];
		t1 = _AX = (t1 * _DX + ( MAX_VOLUME + 1 ) / 2) >> LOG2_VOLUME;
		asm {
			sub	ax, 8
			jae	OK
			xor	ax, ax
		}
OK:		t2 = _AX;
	}

	t1 = 63 - t1;
	t2 = 63 - t2;

	if(vc >= BD && percussion) t1 |= GetLocPrm (slot, prmKsl) << 6;
	else {
		t1 |= (_AX=GetLocPrm (slot, prmKsl) << 6);
		t2 |= _AX;
		SndOutput3(0x40 + (int)offsetSlot [slot], t2);
	}

	SndOutput(0x40 + (int)offsetSlot [slot], t1);
}



/* --------------------------------------------
	Write to the register which controls the note select parameter.
*/
static void near SndSNoteSel()
{
	SndOutput(0x08, noteSel ? 64 : 0);
}	/* SndSNoteSel() */


/*
	Set the values: AM Depth, VIB depth & Rhythm (melo/perc mode)
*/
static void near SndSAmVibRhythm()
{
	_CX = amDepth ? 0x80 : 0;
	_CX |= vibDepth ? 0x40 : 0;
	_CX |= percussion ? 0x20 : 0;
	_CX |= percBits;
	SndOutput(0xBD, _CX);
}

int SetFreq(int voice, unsigned note, int pitch, int keyOn)
{
	asm {
		mov	ax, pitch
		sub	ax, 0x2000
		je	A_M

		sar	ax, 1
		sar	ax, 1
		sar	ax, 1
		sar	ax, 1
		sar	ax, 1
	}
A_M:	asm {
		add	ah, byte ptr note
		add	ax, (1 SHL (LOG_PITCH - LOG_NB_STEP_PITCH - 1))
		sar	ax, 1
		sar	ax, 1
		sar	ax, 1
		sar	ax, 1
		jge	L3
		xor	ax, ax
		jmp	L4
	}
L3:	asm {
		cmp	ax, (NB_NOTES SHL LOG_NB_STEP_PITCH)-1
		jl	L4
		mov	ax, (NB_NOTES SHL LOG_NB_STEP_PITCH)-1
	}
L4:	asm {
		mov	di, ax
		shr	di, 1
		shr	di, 1
		shr	di, 1
		shr	di, 1
		mov	dx, di
		mov	bl, byte ptr noteMOD12[di]
		xor	bh, bh
		mov	di, bx
		shl	di, 1
		shl	di, 1
		shl	di, 1
		shl	di, 1
		shl	di, 1
		shl	ax, 1
		and	ax, (NB_STEP_PITCH * 2 -1)
		add	di, ax
		mov	ax, word ptr fNumTbl[di]
		mov	di, dx
		mov	bl, byte ptr noteDIV12[di]
		dec	bl
		or	ax, ax
		jge	L5
		inc	bl
	}
L5:	asm {
		or	bl, bl
		jge	L6
		inc	bl
		sar	ax, 1
	}
L6:	asm {
		push	bx
		push	ax
		xor	ah, ah
		mov	dx, ax
		mov	al, 0xA0
		add	al, byte ptr voice
		mov	cx, ax
	}
	SndOutput(_CX, _DX);
	asm {
		pop	ax
		pop	bx
		mov	al, ah
		and	al, 3
		shl	bl, 1
		shl	bl, 1
		add	al, bl
		add	al, byte ptr keyOn
		xor	ah, ah
		push	ax
		mov	dx, ax
		mov	al, 0xB0
		add	al, byte ptr voice
		mov	cx, ax
	}
	SndOutput(_CX, _DX);
	asm	pop	ax;

	return _AX;
}

/*
	Change pitch, pitchBend & keyOn of voices 0 to 8, for melodic
	or percussive mode.
*/
static void near UpdateFNums (voice)
{
	bxRegister [voice] = SetFreq (voice, voiceNote [voice],
								  vPitchBend [voice], voiceKeyOn [voice]);

	if(percussion && voice>BD) return;

	SndOutput3(0xA0 + voice, ymbuf[voice]);
	SndOutput3(0xB0 + voice, ymbuf[0x10 + voice]);
}


/*
	Return 0 if board is not installed.  The chip's timers are used to
	determined if an Ad Lib card is present.  When being used, the timers
	place specific values in the status register.  If we do not read the
	correct values from the status register, then we can assume that no
	board is present.
*/
static near int BoardInstalled()
{
	unsigned t1, t2, i;

	SndOutput(4, 0x60);    /* mask T1 & T2 */
	SndOutput(4, 0x80);    /* reset IRQ */
	t1 = inp (genAddr);     /* read status register */
	SndOutput(2, 0xff);    /* set timer-1 latch */
	SndOutput(4, 0x21);    /* unmask & start T1 */

	for (i = 0; i < 200; i++)   /* 100 uSec delay for timer-1 overflow */
		inp (genAddr);

	t2 = inp (genAddr);     /* read status register */
	SndOutput(4, 0x60);
	SndOutput(4, 0x80);

	return (t1 & 0xE0) == 0 && (t2 & 0xE0) == 0xC0;
}


/***************************************************************************/

static void NoV(void)
{
}

static void SndOutput(int addr, int value)
{

	if(addr>=0xA0) ymbuf[addr-0xA0] = value;

	asm {
		mov	dx, genAddr
		mov	ax, addr
		out	dx, al

		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		inc	dx
		mov	ax, value
		out	dx, al

		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx
	}
}

static void SndOutput2_S(int addr, int value)
{
	if(addr>=0xA0) ymbuf[addr-0xA0] = value;

	asm {
		mov	dx, genAddr
		mov	cx, value
		mov	ax, addr
		mov	bx, ax
		out	dx, al

		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx

		inc	dx
		mov	ax, cx
		out	dx, al

		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx

		inc	dx
		mov	ax, bx
		out	dx, al

		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx

		inc	dx
		mov	ax, cx
		out	dx, al

		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx
	}
}

static void SndOutput3_S(int addr, int value)
{
	if(addr>=0xA0) ymbuf[addr-0xA0] = value;

	asm {
		mov	dx, genAddr
		add	dx, 2
		mov	ax, addr
		out	dx, al

		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx

		inc	dx
		mov	ax, value
		out	dx, al

		mov	cx, 2
	}
L14:	asm {
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx

		loop	L14
	}
}

static void SetStereo_RNE (int chan)
{
	int val;

	_BX = ((chan<9) ? chan : 17-chan);

	val = (ymbuf[_BX + 0x20] & 0xCF) | Stereo[_BX];

	asm {
		mov	dx, genAddr
		mov	al, bl
		add	al, 0xC0
		out	dx, al

		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx

		inc	dx
		mov	ax, val
		out	dx, al

		mov	cx, 6
	}
L15:	asm {
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx

		loop	L15
	}
}

static void SetStereo_RE (int chan)
{
	int val;

	_BX = ((chan<9) ? chan : 17-chan);

	val = (ymbuf[_BX + 0x20] & 0xCF) | Stereo[_BX];

	asm {
		mov	dx, genAddr
		mov	al, bl
		add	al, 0xC0
		out	dx, al

		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx

		inc	dx
		mov	ax, val
		out	dx, al

		mov	cx, 3
	}
L16:	asm {
		in	al, dx
		in	al, dx
		in	al, dx
		in	al, dx

		in	al, dx
		in	al, dx

		loop	L16
	}

	if(!(percussion && _BX>BD) && Stereo[_BX]<0x30) {
		asm {
			inc	dx
			mov	al, bl
			add	al, 0xC0
			out	dx, al

			in	al, dx
			in	al, dx
			in	al, dx
			in	al, dx

			in	al, dx
			in	al, dx

			inc	dx
			mov	ax, val
			and	al, 0x0F
			or	al, 0x30
			out	dx, al

			mov	cx, 2
		}
L17:		asm {
			in	al, dx
			in	al, dx
			in	al, dx
			in	al, dx

			in	al, dx
			in	al, dx

			loop	L17
		}
	}
}

int GetStereoStatus(void)
{
	return StereoStatus;
}

int GetEffectStatus(void)
{
	return EffectStatus;
}

int GetYMF262Status(void)
{
	return YM262Status;
}

int GetStereoParam(int chan, int mode)
{
	if(YM262Status || mode==1) {
		if(chan>8) chan=17-chan;
		return (int)(Stereo[chan]>>4);
	}
	else return 3;
}

void SetStereoStatus(int value)
{
	StereoStatus=value;
}

void SetEffectStatus(int value)
{
	EffectStatus=value;
}

void SetStereoParam(int chan, int value)
{
	if(chan>8) chan=17-chan;
	Stereo[chan]=(int)(value<<4);
	if(SetStereo1) SetStereo1(chan);
}

void SetYM_262(int VX)
{
	SndOutput3_S(5, VX);
	if((unsigned)(VX&1)) SndOutput3_S(4, 0);
}

unsigned GetAddr(void)
{
	return genAddr;
}