/*
	Testing SOP - Coded by Park Jeenhong

	All rights on SOP format reserved by Lee Ho-Bum.
	SOP - Copyright (c) 1995, 1996 sopepos (Lee Ho-Bum)

	And the information on the tempo of SOP file is
	maxidea(Seo Jae-hyung)'s.

	Special thanks to them.
*/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <alloc.h>
#include <dos.h>
#include <bios.h>
#include <string.h>
#include "adlib262.h"

#define	VERSION	"1.21"
#define	MAX_TRACK	22

#ifndef __LARGE__
#error Should be compiled in LARGE model
#endif

long CH_SIZE[MAX_TRACK], cur_tempo, ACC_TEMPO, ACC_TEMPO2, TICKS, MAX_TICK[MAX_TRACK], EVENT_LEFT[MAX_TRACK];
int TPB, DELAY_TIME, PITS[MAX_TRACK], PITSN[200], MAC=0, NOTES[MAX_TRACK], NOTEN[200], MAC2=0;
int VOLN[200], MAC5=0, PANS[MAX_TRACK], PANN[100], MAC6=0;
int PONS[MAX_TRACK], Percussion, G_Volume=100, G_Volume2=127, Num_chan;
unsigned TEMPO;
int END, cur_vol[MAX_TRACK], TI[MAX_TRACK];
char *SOP[MAX_TRACK], *USOP[MAX_TRACK], SONG[30], OP_CHAN[MAX_TRACK];

struct INST {
	unsigned char mode;
	unsigned char insname[28];
	unsigned char insdata[23];
};

struct INST *insbuffer, *instbuf;

union scan {
	unsigned c;
	unsigned char ch[2];
} sc;

int Load_SOP(char *);
void Lread(void *, long, FILE *);
void Fast_Pitch(void), Start_SOP(void), End_SOP(void);
void sop_tem_rt(unsigned);

void main(int argc, char *argv[])
{
	int xl, INST_NUM, BTEM=-1, G_VOL=0;
	char STAT[]="RMLN";

	if(argc<2) {
		printf("TS SOP_Filename\n");
		return;
	}

	INST_NUM=Load_SOP(argv[1]);

	Fast_Pitch();

	for(xl=0; xl<MAX_TRACK; xl++) PITS[xl]=0;

	Start_SOP();
	gotoxy(1, 1);
	textattr(0x1B);
	cprintf(" Ch   Instrument              Pit  Vol Pan Nte ");
	textattr(0x0E);
	gotoxy(60, 1);
	cprintf("Instrument : %d ", INST_NUM);
	gotoxy(60, 5);
	cprintf("Initialized : %Xh ", GetAddr_SOP());
	gotoxy(60, 23);
	cprintf("Press Esc to Exit");
	gotoxy(1, 23);
	textattr(0x1B);
	cprintf(" Title : %s ", SONG);
	textattr(0x07);
	while(END>0 && sc.ch[0]!='\x1B') {
		if(bioskey(1)) {
			sc.c=bioskey(0);
			if(sc.ch[1]==75 && ACC_TEMPO>2) ACC_TEMPO-=2;
			if(sc.ch[1]==77 && ACC_TEMPO<200) ACC_TEMPO+=2;
			if(sc.ch[1]==80 && G_Volume>0) G_Volume-=2;
			if(sc.ch[1]==72 && G_Volume<100) G_Volume+=2;
		}
		if(MAC>0) {
			xl=PITSN[--MAC];
			gotoxy(1, 2+xl);
			if(xl>5 && xl<11 && Percussion) textattr(3+xl);
			else textattr(0x0E);
			if(PITS[xl]>=0) cprintf(" %2d   %-20s ", xl+1, (insbuffer+PITS[xl])->insname+8);
			textattr(0x07);
		}
		if(MAC2>0) {
			xl=NOTEN[--MAC2];
			gotoxy(30, 2+xl);
			printf(" %3d ", NOTES[xl]);
			gotoxy(45, 2+xl);
			if(PONS[xl]) printf("P", PONS[xl]);
			else printf(" ");
		}
		if(MAC5>0) {
			xl=VOLN[--MAC5];
			gotoxy(35, 2+xl);
			printf(" %3d ", cur_vol[xl]);
		}
		if(MAC6>0) {
			xl=PANN[--MAC6];
			gotoxy(40, 2+xl);
			printf(" %c ", STAT[PANS[xl]]);
		}
		if(BTEM!=(int)TEMPO) {
			gotoxy(60, 2);
			printf("Tempo : %d ", TEMPO);
			BTEM=TEMPO;
		}
		if(ACC_TEMPO!=ACC_TEMPO2) {
			gotoxy(60, 7);
			printf("Acceleration : %d%% ", ACC_TEMPO);
			ACC_TEMPO2=ACC_TEMPO;
			sop_tem_rt((unsigned)(TEMPO*ACC_TEMPO/100));
		}
		if(G_VOL!=G_Volume) {
			gotoxy(60, 8);
			printf("Amplify : %d%% ", G_Volume);
			for(xl=0;xl<20;xl++) SetVoiceVolume_SOP(xl, (unsigned)((cur_vol[xl]*G_Volume/100*G_Volume2)>>7));
			G_VOL=G_Volume;
		}
	}

	gotoxy(1, 24);
	End_SOP();

	textattr(0x0B);
	if(END>=0) cprintf("\r\nTS V%s, Programmed by Park Jeenhong\r\nSpecial thanks to sopepos", VERSION);
	else printf("\r\nTS - Abnormal SOP Format Error");
	textattr(0x07);
	cprintf("\r\n");
}

void Start_SOP(void)
{
	register int xl;

	TICKS=0;
	DELAY_TIME=240/TPB;
	ACC_TEMPO=100;
	ACC_TEMPO2=0;
	TEMPO=255;
	clrscr();
	sop_tem_rt(255);

	xl=SoundColdInit_SOP(0);
	if(!xl) {
		printf("Error - Cannot detect adlib compatible card\n");
		SetClkRate(0);
		Clk_uninstall();
		SetYM_262_SOP(0);
		farfree(insbuffer);
		for(xl=0;xl<Num_chan+1;xl++) farfree(SOP[xl]);
		exit(0);
	}

	for(xl=0; xl<Num_chan; xl++) if(OP_CHAN[xl]==1) Set_4OP_Mode(xl, 1);

	SetMode_SOP(Percussion);

	for(xl=0;xl<Num_chan+1;xl++) {
		if(xl<20) {
			if((Percussion && (xl<=6 || xl>10)) || !Percussion) {
				SetVoiceTimbre_SOP(xl, insbuffer->insdata);
				SetVoiceVolume_SOP(xl, 96);
			}
			NoteOff_SOP(xl);
		}
		TI[xl]=0;
		MAX_TICK[xl]=0;
		cur_vol[xl]=96;
	}


	Clk_install();
	StartTimeOut(10);
}

void End_SOP(void)
{
	register int xl;

	SetClkRate(0);
	Clk_uninstall();

	for(xl=0;xl<20;xl++) {
		NoteOff_SOP(xl);
		SetVoiceVolume_SOP(xl, 0);
	}

	SetYM_262_SOP(0);

	farfree(insbuffer);
	for(xl=0;xl<Num_chan+1;xl++) farfree(SOP[xl]);
}

void Lread(void *buffer, long size, FILE *fp)
{
	register int xl;
	unsigned RSIZE=(unsigned)(size/32768), RSIZER=size%32768;
	char *nbuffer;
	unsigned SEG_B, OFF_B;

	SEG_B=FP_SEG(buffer);
	OFF_B=FP_OFF(buffer);
	nbuffer=MK_FP(SEG_B, OFF_B);

	for(xl=0;xl<RSIZE;xl++) {
		fread(nbuffer, 32768, 1, fp);
		SEG_B+=2048;
		nbuffer=MK_FP(SEG_B, OFF_B);
	}

	fread(nbuffer, RSIZER, 1, fp);
}

int Load_SOP(char *fname)
{
	register int xl;
	int INST_NUM;
	unsigned IMSI, SEG_A, OFF_A;
	char buffer[8];
	FILE *fp;

	fp=fopen(fname, "rb");
	if(!fp) {
		printf("File not found - %s\n", fname);
		exit(0);
	}
	fread(buffer, 7, 1, fp);
	buffer[7]=NULL;
	if(strcmp(buffer, "sopepos")!=0) {
		printf("Not SOP file\n");
		fclose(fp);
		exit(0);
	}
	fread(buffer, 2, 1, fp);
	if(buffer[0]!=NULL || buffer[1]!='\x01') {
		printf("This program is designed for SOP format version 0.1\n");
		exit(0);
	}
	fseek(fp, 14, SEEK_CUR);
	fread(SONG, 30, 1, fp);
	SONG[30]=NULL;
	fseek(fp, 0x36, SEEK_SET);
	fread(&Percussion, 2, 1, fp);
	fread(&TPB, 2, 1, fp);
	fseek(fp, 0x49, SEEK_SET);
	Num_chan=(unsigned char)fgetc(fp);
	fread(&INST_NUM, 2, 1, fp);
	insbuffer=(struct INST *)farmalloc((long)(INST_NUM)*sizeof(struct INST));
	if(!insbuffer) {
		printf("Memory allocation error!\n");
		exit(0);
	}
	instbuf=insbuffer;
	fseek(fp, 0x4C, SEEK_SET);
	fread(OP_CHAN, Num_chan, 1, fp);
	for(xl=0;xl<INST_NUM;xl++) {
		insbuffer->mode=fgetc(fp);
		fread(insbuffer->insname, 27, 1, fp);
		insbuffer->insname[27]=NULL;
		switch(insbuffer->mode) {
			case	0x0C:	break;
			case	0x00:	fread(insbuffer->insdata, 22, 1, fp);
						break;
			default:		fread(insbuffer->insdata, 11, 1, fp);
						break;
		}
		insbuffer++;
	}
	insbuffer=instbuf;
	INST_NUM=xl;
	END=0;
	for(xl=0;xl<Num_chan+1;xl++) {
		fread(&IMSI, 2, 1, fp);
		if(OP_CHAN[xl]==0 && xl<Num_chan) IMSI=0;
		EVENT_LEFT[xl]=IMSI;
		fread(&CH_SIZE[xl], 4, 1, fp);
		SOP[xl]=farmalloc(CH_SIZE[xl]+32);
		if(!SOP) {
			printf("Memory allocation error!\n");
			exit(0);
		}
		SEG_A=FP_SEG(SOP[xl])+(unsigned)(FP_OFF(SOP[xl])/16)+1;
		OFF_A=0;
		USOP[xl]=MK_FP(SEG_A, OFF_A);
		Lread(USOP[xl], CH_SIZE[xl], fp);
		if(EVENT_LEFT[xl]>0) END++;
	}

	fclose(fp);

	return INST_NUM;
}

void sop_tem_rt(unsigned ttem)
{
	unsigned long rate;

	cur_tempo=ttem;
	rate=(298295LU/ttem);
	SetClkRate(rate);
}

int TimeOut()
{
	int xl, command, DEL, imsi, changed=0, TI_INC;
	unsigned *USOP_INC;
	union scan {
		unsigned c;
		unsigned char ch[2];
	} sc;

	TI[20]--;
	while(TI[20]<=0 && EVENT_LEFT[20]) {
		TI[20]=*((unsigned *)USOP[20])++;
		if(!TICKS && TI[20]) {
			((unsigned *)USOP[20])--;
			break;
		}
		sc.c=*((unsigned *)USOP[20])++;
		if(!(--EVENT_LEFT[20])) END--;
		switch(sc.ch[0]) {
			case	8:	G_Volume2=sc.ch[1];
					changed=1;
					break;
			case 3:	sop_tem_rt((unsigned)(sc.ch[1]*ACC_TEMPO/100));
					TEMPO=sc.ch[1];
					break;
			default:	END=-1;
					return 10;
		}
		if((unsigned)(USOP[20])>32767) USOP[20]=MK_FP(FP_SEG(USOP[20])+(unsigned)(FP_OFF(USOP[20])>>4), FP_OFF(USOP[20])&0x000F);
		TI[20]=*((unsigned *)USOP[20]);
	}

	for(xl=0;xl<20;xl++) {
		TI_INC=TI[xl]-1;
		if(MAX_TICK[xl]==TICKS) {
			NoteOff_SOP(xl);
			PONS[xl]=0;
			NOTEN[MAC2++]=xl;
		}
		if(changed) SetVoiceVolume_SOP(xl, (unsigned)((cur_vol[xl]*G_Volume/100*G_Volume2)>>7));
		USOP_INC=(unsigned *)USOP[xl];
		while(TI_INC<=0 && EVENT_LEFT[xl]) {
			TI_INC=*((unsigned *)USOP_INC)++;
			if(!TICKS && TI_INC) {
				((unsigned *)USOP_INC)--;
				break;
			}
			sc.c=*((unsigned *)USOP_INC)++;
			switch(sc.ch[0]) {
				case	7:	SetStereoPan_SOP((PANN[MAC6++]=xl), (PANS[xl]=sc.ch[1]));
						break;
				case	6:	SetVoiceTimbre_SOP((PITSN[MAC++]=xl), (insbuffer+(PITS[xl]=sc.ch[1]))->insdata);
						break;
				case 5:	SetVoicePitch2_SOP(xl, (signed char)sc.ch[1]);
						break;
				case 4:	SetVoiceVolume_SOP((VOLN[MAC5++]=xl), (unsigned)(((cur_vol[xl]=sc.ch[1])*G_Volume/100*G_Volume2)>>7));
						break;
				case	2:	NoteOn_SOP((NOTEN[MAC2++]=xl), (NOTES[xl]=sc.ch[1]));
						PONS[xl]=1;
						MAX_TICK[xl]=TICKS+*((unsigned *)USOP_INC)++;
						break;
				case	1:	break;
				default:	END=-1;
						return 10;
			}
			if(!(--EVENT_LEFT[xl])) END--;
			if((unsigned)(USOP_INC)>32767) USOP_INC=MK_FP(FP_SEG(USOP_INC)+(unsigned)(FP_OFF(USOP_INC)>>4), FP_OFF(USOP_INC)&0x000F);
			TI_INC=*((unsigned *)USOP_INC);
		}
		USOP[xl]=(unsigned char *)USOP_INC;
		TI[xl]=TI_INC;
	}

	TICKS++;

	return DELAY_TIME;
}

void Fast_Pitch(void)
{
	int xl, command, DEL, TI2, RTS, Note;
	unsigned OFF_A2, SEG_A2;
	char *USOP2;
	long EVENT_LEFT2;

	for(xl=20;xl>=0;xl--) {
		EVENT_LEFT2=EVENT_LEFT[xl];
		USOP2=USOP[xl];
		OFF_A2=FP_OFF(USOP2);
		SEG_A2=FP_SEG(USOP2);
		while(EVENT_LEFT2) {
			EVENT_LEFT2--;
			((unsigned *)USOP2)++;
			command=*((unsigned char *)USOP2)++;
			DEL=*((unsigned char *)USOP2);
			if(command==5) {
				RTS=CalcVoicePitch2_SOP(Note, DEL);
				*((signed char *)USOP2)=(signed char)RTS;
			}
			((unsigned char *)USOP2)++;
			if(command==2) {
				Note=DEL;
				((unsigned *)USOP2)++;
				OFF_A2+=2;
			}
			OFF_A2+=4;
			if(OFF_A2>32767) {
				SEG_A2+=(OFF_A2>>4);
				OFF_A2&=0x000F;
				USOP2=MK_FP(SEG_A2, OFF_A2);
			}
		}
	}
}
